VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CNatSortRelation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Implements IListBoxOrderRelation


Private Function IListBoxOrderRelation_CompareItems(ItemTextA As String, ItemTextB As String, ByVal ItemDataA As Long, ByVal ItemDataB As Long) As Long
    Dim lA As Long
    Dim lB As Long
    Dim ciA As Long
    Dim ciB As Long
    
    Dim ccA As Integer
    Dim ccB As Integer
    
    Dim iCmpRes As Long
    
    lA = Len(ItemTextA)
    lB = Len(ItemTextB)
    
    If lA = 0 And lB = 0 Then
        IListBoxOrderRelation_CompareItems = 0
        Exit Function
    End If
    
    ciA = 1
    ciB = 1
    
    Do
        ccA = AscW(Mid$(ItemTextA, ciA, 1))
        If Not IsSpaceChar(ccA) Then Exit Do
        ciA = ciA + 1
    Loop Until ciA > lA
    
    Do
        ccB = AscW(Mid$(ItemTextB, ciB, 1))
        If Not IsSpaceChar(ccB) Then Exit Do
        ciB = ciB + 1
    Loop Until ciB > lB
    
    GoSub CheckEolCondition

    
    Do
        ccA = AscW(Mid$(ItemTextA, ciA, 1))
        ccB = AscW(Mid$(ItemTextB, ciB, 1))
        
        If IsSpaceChar(ccA) And IsSpaceChar(ccB) Then
            Do
                ciA = ciA + 1
                If ciA > lA Then Exit Do
                ccA = AscW(Mid$(ItemTextA, ciA, 1))
                If Not IsSpaceChar(ccA) Then Exit Do
            Loop
            
            Do
                ciB = ciB + 1
                If ciB > lB Then Exit Do
                ccB = AscW(Mid$(ItemTextB, ciB, 1))
                If Not IsSpaceChar(ccB) Then Exit Do
            Loop
        ElseIf IsDigitChar(ccA) And IsDigitChar(ccB) Then
            Dim dgAfc As Long
            Dim dgAlc As Long
           
            dgAfc = ciA
            dgBfc = ciB
        
            Do
                ciA = ciA + 1
                If ciA > lA Then
                    dgAlc = ciA - 1
                    Exit Do
                End If
                ccA = AscW(Mid$(ItemTextA, ciA, 1))
                If Not IsPartOfNumber(ccA) Then
                    dgAlc = ciA - 1
                    Exit Do
                End If
            Loop
            
            Do
                ciB = ciB + 1
                If ciB > lB Then
                    dgBlc = ciB
                    Exit Do
                End If
                ccB = AscW(Mid$(ItemTextB, ciB, 1))
                If Not IsPartOfNumber(ccB) Then
                    dgBlc = ciB - 1
                    Exit Do
                End If
            Loop
            
            Dim vA As Long
            Dim vB As Long
            
            vA = Val(Mid$(ItemTextA, dgAfc, ciA))
            vB = Val(Mid$(ItemTextB, dgBfc, ciB))
            
            If vA < vB Then
                IListBoxOrderRelation_CompareItems = -1
                Exit Function
            ElseIf vA > vB Then
                IListBoxOrderRelation_CompareItems = 1
                Exit Function
            End If
        Else
            iCmpRes = StrComp(ChrW$(ccA), ChrW$(ccB), vbTextCompare)
            
            If iCmpRes <> 0 Then
                IListBoxOrderRelation_CompareItems = iCmpRes
                Exit Function
            End If
            
            ciA = ciA + 1
            ciB = ciB + 1
        End If
        
        GoSub CheckEolCondition
    Loop
    
    Exit Function
CheckEolCondition:
    If ciA > lA Or ciB > lB Then
        If ciA > lA And ciB > lB Then
            IListBoxOrderRelation_CompareItems = 0
            
        ElseIf (lA - ciA) > (lB - ciB) Then
            IListBoxOrderRelation_CompareItems = 1
        Else
            IListBoxOrderRelation_CompareItems = -1
        End If
    
        Exit Function
    End If
    Return
End Function

Private Function IsSpaceChar(ByVal cc As Integer) As Boolean
    Select Case cc
        Case vbKeySpace, vbKeyTab, 160: IsSpaceChar = True
    End Select
End Function

Private Function IsDigitChar(ByVal cc As Integer) As Boolean
    IsDigitChar = (cc >= vbKey0) And (cc <= vbKey9)
End Function

Private Function IsPartOfNumber(ByVal cc As Integer) As Boolean
    Const ASCII_PERIOD = 46
    Const ASCII_COMMA = 44
    Select Case cc
        Case vbKey0 To vbKey9, ASCII_PERIOD, ASCII_COMMA: IsPartOfNumber = True
    End Select
End Function


